*** a/src/backend/parser/parse_agg.c
--- b/src/backend/parser/parse_agg.c
***************
*** 44,50 **** typedef struct
  	int			sublevels_up;
  } check_ungrouped_columns_context;
  
! static int	check_agg_arguments(ParseState *pstate, List *args, Expr *filter);
  static bool check_agg_arguments_walker(Node *node,
  						   check_agg_arguments_context *context);
  static void check_ungrouped_columns(Node *node, ParseState *pstate, Query *qry,
--- 44,52 ----
  	int			sublevels_up;
  } check_ungrouped_columns_context;
  
! static int	check_agg_arguments(ParseState *pstate, 
! 							List *args, 
! 							List *agg_ordset, Expr *filter);
  static bool check_agg_arguments_walker(Node *node,
  						   check_agg_arguments_context *context);
  static void check_ungrouped_columns(Node *node, ParseState *pstate, Query *qry,
***************
*** 75,81 **** static bool check_ungrouped_columns_walker(Node *node,
   */
  void
  transformAggregateCall(ParseState *pstate, Aggref *agg,
! 					   List *args, List *aggorder, bool agg_distinct)
  {
  	List	   *tlist;
  	List	   *torder;
--- 77,84 ----
   */
  void
  transformAggregateCall(ParseState *pstate, Aggref *agg,
! 					   List *args, List *aggorder,
! 					   bool agg_distinct, bool agg_within_group)
  {
  	List	   *tlist;
  	List	   *torder;
***************
*** 93,104 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
  	 */
  	tlist = NIL;
  	attno = 1;
! 	foreach(lc, args)
  	{
! 		Expr	   *arg = (Expr *) lfirst(lc);
! 		TargetEntry *tle = makeTargetEntry(arg, attno++, NULL, false);
  
! 		tlist = lappend(tlist, tle);
  	}
  
  	/*
--- 96,119 ----
  	 */
  	tlist = NIL;
  	attno = 1;
! 
! 	if (agg_within_group)
  	{
! 		agg->isordset = TRUE;
! 		agg->orddirectargs = args;
! 	}
! 	else
! 	{
! 		foreach(lc, args)
! 		{
! 			Expr	   *arg = (Expr *) lfirst(lc);
! 			TargetEntry *tle = makeTargetEntry(arg, attno++, NULL, false);
  
! 			tlist = lappend(tlist, tle);
! 		}
! 
! 		agg->isordset = FALSE;
! 		agg->orddirectargs = NIL;
  	}
  
  	/*
***************
*** 109,114 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
--- 124,134 ----
  	 *
  	 * We need to mess with p_next_resno since it will be used to number any
  	 * new targetlist entries.
+ 	 *
+ 	 * If and only if we're doing a WITHIN GROUP list, we preserve any
+ 	 * duplicate expressions in the sort clause. This is needed because the
+ 	 * sort clause of WITHIN GROUP is really an argument list, and we must
+ 	 * keep the number and content of entries matching the specified input.
  	 */
  	save_next_resno = pstate->p_next_resno;
  	pstate->p_next_resno = attno;
***************
*** 118,124 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
  								 &tlist,
  								 EXPR_KIND_ORDER_BY,
  								 true /* fix unknowns */ ,
! 								 true /* force SQL99 rules */ );
  
  	/*
  	 * If we have DISTINCT, transform that to produce a distinctList.
--- 138,145 ----
  								 &tlist,
  								 EXPR_KIND_ORDER_BY,
  								 true /* fix unknowns */ ,
! 								 true /* force SQL99 rules */ ,
! 								 agg_within_group /* keep duplicates? */ );
  
  	/*
  	 * If we have DISTINCT, transform that to produce a distinctList.
***************
*** 160,166 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
  	 * Check the arguments to compute the aggregate's level and detect
  	 * improper nesting.
  	 */
! 	min_varlevel = check_agg_arguments(pstate, agg->args, agg->aggfilter);
  	agg->agglevelsup = min_varlevel;
  
  	/* Mark the correct pstate level as having aggregates */
--- 181,188 ----
  	 * Check the arguments to compute the aggregate's level and detect
  	 * improper nesting.
  	 */
! 	min_varlevel = check_agg_arguments(pstate, 
! 										agg->args, agg->orddirectargs, agg->aggfilter);
  	agg->agglevelsup = min_varlevel;
  
  	/* Mark the correct pstate level as having aggregates */
***************
*** 312,318 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
   * which we can't know until we finish scanning the arguments.
   */
  static int
! check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
  {
  	int			agglevel;
  	check_agg_arguments_context context;
--- 334,340 ----
   * which we can't know until we finish scanning the arguments.
   */
  static int
! check_agg_arguments(ParseState *pstate, List *args, List *agg_ordset, Expr *filter)
  {
  	int			agglevel;
  	check_agg_arguments_context context;
***************
*** 330,335 **** check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
--- 352,360 ----
  								  check_agg_arguments_walker,
  								  (void *) &context);
  
+ 	(void) expression_tree_walker((Node *) agg_ordset,	  check_agg_arguments_walker,
+ 								  (void *) &context);
+ 
  	/*
  	 * If we found no vars nor aggs at all, it's a level-zero aggregate;
  	 * otherwise, its level is the minimum of vars or aggs.
***************
*** 353,360 **** check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
  				(errcode(ERRCODE_GROUPING_ERROR),
  				 errmsg("aggregate function calls cannot be nested"),
  				 parser_errposition(pstate,
! 									locate_agg_of_level((Node *) args,
! 														agglevel))));
  
  	return agglevel;
  }
--- 378,385 ----
  				(errcode(ERRCODE_GROUPING_ERROR),
  				 errmsg("aggregate function calls cannot be nested"),
  				 parser_errposition(pstate,
! 								locate_agg_of_level((Node *) args,
! 								agglevel))));
  
  	return agglevel;
  }
***************
*** 823,830 **** check_ungrouped_columns_walker(Node *node,
  	 * We do need to look at aggregates of lower levels, however.
  	 */
  	if (IsA(node, Aggref) &&
! 		(int) ((Aggref *) node)->agglevelsup >= context->sublevels_up)
  		return false;
  
  	/*
  	 * If we have any GROUP BY items that are not simple Vars, check to see if
--- 848,863 ----
  	 * We do need to look at aggregates of lower levels, however.
  	 */
  	if (IsA(node, Aggref) &&
! 		(int) ((Aggref *) node)->agglevelsup > context->sublevels_up)
! 	{
  		return false;
+ 	}
+ 	else if (IsA(node, Aggref) &&
+ 			(int) ((Aggref *) node)->agglevelsup == context->sublevels_up)
+ 	{
+ 		return check_ungrouped_columns_walker((Node*)(((Aggref *)node)->orddirectargs), 
+ 														context);
+ 	}
  
  	/*
  	 * If we have any GROUP BY items that are not simple Vars, check to see if
***************
*** 1042,1044 **** build_aggregate_fnexprs(Oid *agg_input_types,
--- 1075,1172 ----
  										 agg_input_collation,
  										 COERCE_EXPLICIT_CALL);
  }
+ 
+ void
+ build_orderedset_fnexprs(Oid *agg_input_types,
+ 						 int agg_num_inputs,
+ 						 bool agg_variadic,
+ 						 Oid agg_result_type,
+ 						 Oid agg_input_collation,
+ 						 Oid *agg_input_collation_array,
+ 						 Oid finalfn_oid,
+ 						 Expr **finalfnexpr)
+ {
+ 	FuncExpr   *fexpr;
+ 	Param	   *argp;
+ 	List	   *args = NIL;
+ 	int			i = 0;
+ 
+ 	/*
+ 	 * Build arg list to use in the finalfn FuncExpr node. We really only care
+ 	 * that finalfn can discover the actual argument types at runtime using
+ 	 * get_fn_expr_argtype(), so it's okay to use Param nodes that don't
+ 	 * correspond to any real Param.
+ 	 */
+ 	for (i = 0; i < agg_num_inputs; i++)
+ 	{
+ 		argp = makeNode(Param);
+ 		argp->paramkind = PARAM_EXEC;
+ 		argp->paramid = -1;
+ 		argp->paramtype = agg_input_types[i];
+ 		argp->paramtypmod = -1;
+ 		argp->paramcollid = agg_input_collation_array[i];
+ 		argp->location = -1;
+ 
+ 		args = lappend(args, argp);
+ 	}
+ 
+ 	fexpr = makeFuncExpr(finalfn_oid,
+ 						 agg_result_type,
+ 						 args,
+ 						 InvalidOid,
+ 						 agg_input_collation,
+ 						 COERCE_EXPLICIT_CALL);
+ 	fexpr->funcvariadic = agg_variadic;
+ 	*finalfnexpr = (Expr *) fexpr;
+ }
+ 
+ int get_aggregate_argtypes(Aggref *aggref, Oid *inputTypes, Oid *inputCollations)
+ {
+ 	int numArguments = 0;
+ 	ListCell   *lc;
+ 
+ 	if (!(aggref->isordset))
+ 	{
+ 		foreach(lc, aggref->args)
+ 		{
+ 			TargetEntry *tle = (TargetEntry *) lfirst(lc);
+ 
+ 			if (!tle->resjunk)
+ 			{
+ 				inputTypes[numArguments] = exprType((Node *) tle->expr);
+ 				if (inputCollations != NULL)
+ 					inputCollations[numArguments] = exprCollation((Node *) tle->expr);
+ 				++numArguments;
+ 			}
+ 		}
+ 	}
+ 	else
+ 	{
+ 		foreach(lc, aggref->orddirectargs)
+ 		{
+ 			Node *expr_orddirectargs = lfirst(lc);
+ 
+ 			inputTypes[numArguments] = exprType(expr_orddirectargs);
+ 			if (inputCollations != NULL)
+ 				inputCollations[numArguments] = exprCollation(expr_orddirectargs);
+ 
+ 			++numArguments;
+ 		}
+ 
+ 		if (!(aggref->ishypothetical))
+ 		{
+ 			foreach(lc, aggref->args)
+ 			{
+ 				TargetEntry *tle = (TargetEntry *) lfirst(lc);
+ 
+ 				inputTypes[numArguments] = exprType((Node *) tle->expr);
+ 				if (inputCollations != NULL)
+ 					inputCollations[numArguments] = exprCollation((Node *) tle->expr);
+ 
+ 				++numArguments;
+ 			}
+ 		}
+ 	}
+ 
+ 	return numArguments;
+ }
*** a/src/backend/parser/parse_clause.c
--- b/src/backend/parser/parse_clause.c
***************
*** 71,77 **** static void checkExprIsVarFree(ParseState *pstate, Node *n,
  static TargetEntry *findTargetlistEntrySQL92(ParseState *pstate, Node *node,
  						 List **tlist, ParseExprKind exprKind);
  static TargetEntry *findTargetlistEntrySQL99(ParseState *pstate, Node *node,
! 						 List **tlist, ParseExprKind exprKind);
  static int get_matching_location(int sortgroupref,
  					  List *sortgrouprefs, List *exprs);
  static List *addTargetToSortList(ParseState *pstate, TargetEntry *tle,
--- 71,78 ----
  static TargetEntry *findTargetlistEntrySQL92(ParseState *pstate, Node *node,
  						 List **tlist, ParseExprKind exprKind);
  static TargetEntry *findTargetlistEntrySQL99(ParseState *pstate, Node *node,
! 											 List **tlist, ParseExprKind exprKind,
! 											 bool keepDuplicates);
  static int get_matching_location(int sortgroupref,
  					  List *sortgrouprefs, List *exprs);
  static List *addTargetToSortList(ParseState *pstate, TargetEntry *tle,
***************
*** 1476,1482 **** findTargetlistEntrySQL92(ParseState *pstate, Node *node, List **tlist,
  	/*
  	 * Otherwise, we have an expression, so process it per SQL99 rules.
  	 */
! 	return findTargetlistEntrySQL99(pstate, node, tlist, exprKind);
  }
  
  /*
--- 1477,1483 ----
  	/*
  	 * Otherwise, we have an expression, so process it per SQL99 rules.
  	 */
! 	return findTargetlistEntrySQL99(pstate, node, tlist, exprKind, false);
  }
  
  /*
***************
*** 1491,1500 **** findTargetlistEntrySQL92(ParseState *pstate, Node *node, List **tlist,
   * node		the ORDER BY, GROUP BY, etc expression to be matched
   * tlist	the target list (passed by reference so we can append to it)
   * exprKind identifies clause type being processed
   */
  static TargetEntry *
  findTargetlistEntrySQL99(ParseState *pstate, Node *node, List **tlist,
! 						 ParseExprKind exprKind)
  {
  	TargetEntry *target_result;
  	ListCell   *tl;
--- 1492,1502 ----
   * node		the ORDER BY, GROUP BY, etc expression to be matched
   * tlist	the target list (passed by reference so we can append to it)
   * exprKind identifies clause type being processed
+  * keepDuplicates  if true, don't try and match to any existing entry
   */
  static TargetEntry *
  findTargetlistEntrySQL99(ParseState *pstate, Node *node, List **tlist,
! 						 ParseExprKind exprKind, bool keepDuplicates)
  {
  	TargetEntry *target_result;
  	ListCell   *tl;
***************
*** 1509,1532 **** findTargetlistEntrySQL99(ParseState *pstate, Node *node, List **tlist,
  	 */
  	expr = transformExpr(pstate, node, exprKind);
  
! 	foreach(tl, *tlist)
  	{
! 		TargetEntry *tle = (TargetEntry *) lfirst(tl);
! 		Node	   *texpr;
  
! 		/*
! 		 * Ignore any implicit cast on the existing tlist expression.
! 		 *
! 		 * This essentially allows the ORDER/GROUP/etc item to adopt the same
! 		 * datatype previously selected for a textually-equivalent tlist item.
! 		 * There can't be any implicit cast at top level in an ordinary SELECT
! 		 * tlist at this stage, but the case does arise with ORDER BY in an
! 		 * aggregate function.
! 		 */
! 		texpr = strip_implicit_coercions((Node *) tle->expr);
  
! 		if (equal(expr, texpr))
! 			return tle;
  	}
  
  	/*
--- 1511,1537 ----
  	 */
  	expr = transformExpr(pstate, node, exprKind);
  
! 	if (!keepDuplicates)
  	{
! 		foreach(tl, *tlist)
! 		{
! 			TargetEntry *tle = (TargetEntry *) lfirst(tl);
! 			Node	   *texpr;
  
! 			/*
! 			 * Ignore any implicit cast on the existing tlist expression.
! 			 *
! 			 * This essentially allows the ORDER/GROUP/etc item to adopt the same
! 			 * datatype previously selected for a textually-equivalent tlist item.
! 			 * There can't be any implicit cast at top level in an ordinary SELECT
! 			 * tlist at this stage, but the case does arise with ORDER BY in an
! 			 * aggregate function.
! 			 */
! 			texpr = strip_implicit_coercions((Node *) tle->expr);
  
! 			if (equal(expr, texpr))
! 				return tle;
! 		}
  	}
  
  	/*
***************
*** 1568,1574 **** transformGroupClause(ParseState *pstate, List *grouplist,
  
  		if (useSQL99)
  			tle = findTargetlistEntrySQL99(pstate, gexpr,
! 										   targetlist, exprKind);
  		else
  			tle = findTargetlistEntrySQL92(pstate, gexpr,
  										   targetlist, exprKind);
--- 1573,1579 ----
  
  		if (useSQL99)
  			tle = findTargetlistEntrySQL99(pstate, gexpr,
! 										   targetlist, exprKind, false);
  		else
  			tle = findTargetlistEntrySQL92(pstate, gexpr,
  										   targetlist, exprKind);
***************
*** 1635,1645 **** transformSortClause(ParseState *pstate,
  					List **targetlist,
  					ParseExprKind exprKind,
  					bool resolveUnknown,
! 					bool useSQL99)
  {
  	List	   *sortlist = NIL;
  	ListCell   *olitem;
  
  	foreach(olitem, orderlist)
  	{
  		SortBy	   *sortby = (SortBy *) lfirst(olitem);
--- 1640,1653 ----
  					List **targetlist,
  					ParseExprKind exprKind,
  					bool resolveUnknown,
! 					bool useSQL99,
! 	                bool keepDuplicates)
  {
  	List	   *sortlist = NIL;
  	ListCell   *olitem;
  
+ 	Assert(useSQL99 || !keepDuplicates);
+ 
  	foreach(olitem, orderlist)
  	{
  		SortBy	   *sortby = (SortBy *) lfirst(olitem);
***************
*** 1647,1653 **** transformSortClause(ParseState *pstate,
  
  		if (useSQL99)
  			tle = findTargetlistEntrySQL99(pstate, sortby->node,
! 										   targetlist, exprKind);
  		else
  			tle = findTargetlistEntrySQL92(pstate, sortby->node,
  										   targetlist, exprKind);
--- 1655,1661 ----
  
  		if (useSQL99)
  			tle = findTargetlistEntrySQL99(pstate, sortby->node,
! 										   targetlist, exprKind, keepDuplicates);
  		else
  			tle = findTargetlistEntrySQL92(pstate, sortby->node,
  										   targetlist, exprKind);
***************
*** 1717,1723 **** transformWindowDefinitions(ParseState *pstate,
  										  targetlist,
  										  EXPR_KIND_WINDOW_ORDER,
  										  true /* fix unknowns */ ,
! 										  true /* force SQL99 rules */ );
  		partitionClause = transformGroupClause(pstate,
  											   windef->partitionClause,
  											   targetlist,
--- 1725,1732 ----
  										  targetlist,
  										  EXPR_KIND_WINDOW_ORDER,
  										  true /* fix unknowns */ ,
! 										  true /* force SQL99 rules */,
! 			                              false /* don't add duplicates */);
  		partitionClause = transformGroupClause(pstate,
  											   windef->partitionClause,
  											   targetlist,
*** a/src/backend/parser/parse_collate.c
--- b/src/backend/parser/parse_collate.c
***************
*** 73,79 **** typedef struct
  static bool assign_query_collations_walker(Node *node, ParseState *pstate);
  static bool assign_collations_walker(Node *node,
  						 assign_collations_context *context);
! 
  
  /*
   * assign_query_collations()
--- 73,81 ----
  static bool assign_query_collations_walker(Node *node, ParseState *pstate);
  static bool assign_collations_walker(Node *node,
  						 assign_collations_context *context);
! static void assign_aggregate_collations(Aggref *aggref,
! 						assign_collations_context *context,
! 						assign_collations_context *loccontext);
  
  /*
   * assign_query_collations()
***************
*** 564,607 **** assign_collations_walker(Node *node, assign_collations_context *context)
  					case T_Aggref:
  						{
  							/*
! 							 * Aggref is a special case because expressions
! 							 * used only for ordering shouldn't be taken to
! 							 * conflict with each other or with regular args.
! 							 * So we apply assign_expr_collations() to them
! 							 * rather than passing down our loccontext.
! 							 *
! 							 * Note that we recurse to each TargetEntry, not
! 							 * directly to its contained expression, so that
! 							 * the case above for T_TargetEntry will apply
! 							 * appropriate checks to agg ORDER BY items.
! 							 *
! 							 * Likewise, we assign collations for the (bool)
! 							 * expression in aggfilter, independently of any
! 							 * other args.
! 							 *
! 							 * We need not recurse into the aggorder or
! 							 * aggdistinct lists, because those contain only
! 							 * SortGroupClause nodes which we need not
! 							 * process.
  							 */
  							Aggref	   *aggref = (Aggref *) node;
- 							ListCell   *lc;
  
! 							foreach(lc, aggref->args)
! 							{
! 								TargetEntry *tle = (TargetEntry *) lfirst(lc);
! 
! 								Assert(IsA(tle, TargetEntry));
! 								if (tle->resjunk)
! 									assign_expr_collations(context->pstate,
! 														   (Node *) tle);
! 								else
! 									(void) assign_collations_walker((Node *) tle,
! 																&loccontext);
! 							}
  
  							assign_expr_collations(context->pstate,
! 												 (Node *) aggref->aggfilter);
  						}
  						break;
  					case T_WindowFunc:
--- 566,581 ----
  					case T_Aggref:
  						{
  							/*
! 							 * Aggref is special enough that we give it its own
! 							 * function. The FILTER clause is independent of the
! 							 * rest of the aggregate, however.
  							 */
  							Aggref	   *aggref = (Aggref *) node;
  
! 							assign_aggregate_collations(aggref, context, &loccontext);
  
  							assign_expr_collations(context->pstate,
! 												   (Node *) aggref->aggfilter);
  						}
  						break;
  					case T_WindowFunc:
***************
*** 802,804 **** assign_collations_walker(Node *node, assign_collations_context *context)
--- 776,934 ----
  
  	return false;
  }
+ 
+ 
+ /*
+  * Aggref is a special case because expressions used only for ordering
+  * shouldn't be taken to conflict with each other or with regular args.  So we
+  * apply assign_expr_collations() to them rather than passing down our
+  * loccontext.
+  *
+  * Note that we recurse to each TargetEntry, not directly to its contained
+  * expression, so that the case above for T_TargetEntry will apply appropriate
+  * checks to agg ORDER BY items.
+  *
+  * We need not recurse into the aggorder or aggdistinct lists, because those
+  * contain only SortGroupClause nodes which we need not process.
+  *
+  * For ordered set functions, it's unfortunately unclear how best to proceed.
+  * The spec-defined inverse distribution functions have only one sort column
+  * and don't allow collatable types, but this is clearly unsatisfactory in the
+  * general case. Compromise by taking the sort column as part of the collation
+  * determination if, and only if, there is only one such column, and force the
+  * final choice of input collation down into the sort column if need be; but
+  * don't error out unless actually necessary (leaving it up to the function to
+  * handle the issue at runtime). This ugly wart is justified by the fact that
+  * there seems to be no other good way to get a result collation for
+  * percentile_* applied to a collatable type.
+  *
+  * But hypothetical set functions are special; they must have
+  * pairwise-assigned collations for each matching pair of args, and again we
+  * need to force the final choice of collation down into the sort column to
+  * ensure that the sort happens on the chosen collation. If there are any
+  * additional args (not allowed in the spec, but a user-defined function might
+  * have some), those contribute to the result collation in the normal way.
+  * (The hypothetical paired args never contribute to the result collation at
+  * all.)
+  */
+ 
+ static Expr *
+ relabel_expr_collation(Expr *expr, Oid newcollation)
+ {
+ 	RelabelType *node = makeNode(RelabelType);
+ 	node->arg = expr;
+ 	node->resulttype = exprType((Node *)expr);
+ 	node->resulttypmod = exprTypmod((Node *)expr);
+ 	node->resultcollid = newcollation;
+ 	node->relabelformat = COERCE_IMPLICIT_CAST;
+ 	node->location = exprLocation((Node *)expr);
+ 	return (Expr *) node;
+ }
+ 
+ static void
+ assign_aggregate_collations(Aggref *aggref,
+ 							assign_collations_context *context,
+ 							assign_collations_context *loccontext)
+ {
+ 	ListCell   *lc;
+ 
+ 	if (aggref->ishypothetical)
+ 	{
+ 		/*-
+ 		 * Hypothetical set function, i.e.
+ 		 *   func(..., a,b,c,...) within group (p,q,r,...)
+ 		 *
+ 		 * Any initial set of direct args (before "a") contributes to the
+ 		 * result collation in the usual way for function args. But none of
+ 		 * a,b,c... or p,q,r... contribute at all; instead, they must be
+ 		 * paired up (as though UNIONed) and the sorted col's collation forced
+ 		 * to the chosen value (so that we sort it correctly).
+ 		 */
+ 		int initial_args = list_length(aggref->orddirectargs) - list_length(aggref->args);
+ 		ListCell *h_arg = list_head(aggref->orddirectargs);
+ 		ListCell *s_arg = list_head(aggref->args);
+ 
+ 		Assert(initial_args >= 0);
+ 
+ 		while (initial_args-- > 0)
+ 		{
+ 			(void) assign_collations_walker((Node *) lfirst(h_arg), loccontext);
+ 			h_arg = lnext(h_arg);
+ 		}
+ 
+ 		for_each_cell(h_arg,h_arg)
+ 		{
+ 			TargetEntry *tle = (TargetEntry *) lfirst(s_arg);
+ 			Oid coll = select_common_collation(context->pstate,
+ 											   list_make2(lfirst(h_arg),lfirst(s_arg)),
+ 											   false);
+ 
+ 			/*
+ 			 * we can only get InvalidOid here if the type is not collatable,
+ 			 * so no need to try and relabel in that case.
+ 			 */
+ 
+ 			if (OidIsValid(coll)
+ 				&& coll != exprCollation((Node *)(tle->expr)))
+ 			{
+ 				tle->expr = relabel_expr_collation(tle->expr, coll);
+ 			}
+ 
+ 			s_arg = lnext(s_arg);
+ 		}
+ 	}
+ 	else if (aggref->isordset && list_length(aggref->args) == 1)
+ 	{
+ 		/*
+ 		 * Ordered set func with one sorted arg
+ 		 */
+ 		TargetEntry *tle = (TargetEntry *) linitial(aggref->args);
+ 
+ 		/* do the TLE first so that it won't error out on conflicts */
+ 
+ 		(void) assign_collations_walker((Node *) tle,
+ 										loccontext);
+ 
+ 		(void) assign_collations_walker((Node *) aggref->orddirectargs,
+ 										loccontext);
+ 
+ 		/*
+ 		 * If the sort col is a collatable type, and we chose a collation,
+ 		 * and it's not the one the sort col already has, then force the
+ 		 * sort col's collation (which can't have been explicit) to the
+ 		 * chosen one. Otherwise leave it alone.
+ 		 */
+ 		if (type_is_collatable(exprType((Node *)(tle->expr)))
+ 			&& (loccontext->strength == COLLATE_IMPLICIT
+ 				|| loccontext->strength == COLLATE_EXPLICIT)
+ 			&& exprCollation((Node *)(tle->expr)) != loccontext->collation)
+ 		{
+ 			tle->expr = relabel_expr_collation(tle->expr, loccontext->collation);
+ 		}
+ 	}
+ 	else
+ 	{
+ 		/*
+ 		 * For this case, we do the direct args (if any) together, as is
+ 		 * normal for functions, but args which are either used only for
+ 		 * sorting or are only part of a WITHIN GROUP are processed
+ 		 * individually.
+ 		 */
+ 
+ 		(void) assign_collations_walker((Node *) aggref->orddirectargs,
+ 										loccontext);
+ 
+ 		foreach(lc, aggref->args)
+ 		{
+ 			TargetEntry *tle = (TargetEntry *) lfirst(lc);
+ 
+ 			Assert(IsA(tle, TargetEntry));
+ 			if (tle->resjunk)
+ 				assign_expr_collations(context->pstate,
+ 									   (Node *) tle);
+ 			else
+ 				(void) assign_collations_walker((Node *) tle,
+ 												loccontext);
+ 		}
+ 	}
+ }
*** a/src/backend/parser/parse_expr.c
--- b/src/backend/parser/parse_expr.c
***************
*** 463,470 **** transformIndirection(ParseState *pstate, Node *basenode, List *indirection)
  			newresult = ParseFuncOrColumn(pstate,
  										  list_make1(n),
  										  list_make1(result),
! 										  NIL, NULL, false, false, false,
! 										  NULL, true, location);
  			if (newresult == NULL)
  				unknown_attribute(pstate, result, strVal(n), location);
  			result = newresult;
--- 463,470 ----
  			newresult = ParseFuncOrColumn(pstate,
  										  list_make1(n),
  										  list_make1(result),
! 										  location,
! 										  NULL);
  			if (newresult == NULL)
  				unknown_attribute(pstate, result, strVal(n), location);
  			result = newresult;
***************
*** 631,638 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 631,637 ----
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 cref->location, NULL);
  				}
  				break;
  			}
***************
*** 676,683 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 675,681 ----
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 cref->location, NULL);
  				}
  				break;
  			}
***************
*** 734,741 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 732,738 ----
  					node = ParseFuncOrColumn(pstate,
  											 list_make1(makeString(colname)),
  											 list_make1(node),
! 											 cref->location, NULL);
  				}
  				break;
  			}
***************
*** 1242,1279 **** transformFuncCall(ParseState *pstate, FuncCall *fn)
  {
  	List	   *targs;
  	ListCell   *args;
- 	Expr	   *tagg_filter;
  
  	/* Transform the list of arguments ... */
  	targs = NIL;
  	foreach(args, fn->args)
  	{
! 		targs = lappend(targs, transformExprRecurse(pstate,
! 													(Node *) lfirst(args)));
  	}
  
- 	/*
- 	 * Transform the aggregate filter using transformWhereClause(), to which
- 	 * FILTER is virtually identical...
- 	 */
- 	tagg_filter = NULL;
- 	if (fn->agg_filter != NULL)
- 		tagg_filter = (Expr *)
- 			transformWhereClause(pstate, (Node *) fn->agg_filter,
- 								 EXPR_KIND_FILTER, "FILTER");
- 
  	/* ... and hand off to ParseFuncOrColumn */
  	return ParseFuncOrColumn(pstate,
  							 fn->funcname,
  							 targs,
! 							 fn->agg_order,
! 							 tagg_filter,
! 							 fn->agg_star,
! 							 fn->agg_distinct,
! 							 fn->func_variadic,
! 							 fn->over,
! 							 false,
! 							 fn->location);
  }
  
  static Node *
--- 1239,1258 ----
  {
  	List	   *targs;
  	ListCell   *args;
  
  	/* Transform the list of arguments ... */
  	targs = NIL;
  	foreach(args, fn->args)
  	{
! 		targs = lappend(targs, transformExprRecurse(pstate, (Node *) lfirst(args)));
  	}
  
  	/* ... and hand off to ParseFuncOrColumn */
  	return ParseFuncOrColumn(pstate,
  							 fn->funcname,
  							 targs,
! 							 fn->location,
! 							 fn);
  }
  
  static Node *
